:- module(gencore, [main/0]).

:- use_module(library(aggregates),    [findall/3]).
:- use_module(library(terms),         [atom_concat/2] ).

%% FIXME: Should use compiler modules.

% Type operators.
:- op(651, xfy, <@).  % Typevar aplication.
:- op(652, xfy, -->). % Normal apply operator.
:- op(653, xfy, =>).  % Type class constraint.

%% Exports of core

main :- 
	create_core_exports.

module_header :-
	portray_clause((:- module('CoreTypes', [exports/1]))),
	portray_clause((:- discontiguous tohnf/2, tonf/2, is_constructor/1, exports/1)),
	portray_clause((:- op(651, xfy, <@))),  % Typevar aplication.
	portray_clause((:- op(652, xfy, -->))), % Normal apply operator.
	portray_clause((:- op(653, xfy, =>))).  % Type class constraint.


create_core_exports :-
	% Core types.
	module_header,
	export_type(tid('Prelude', [])<@[A], 
	             [(qid('Prelude', []),  tid('Prelude', [])<@[_]),
		      (qid('Prelude', ':'), A --> tid('Prelude', [])<@[A] --> tid('Prelude', [])<@[A])]),
        export_type(tid('Prelude', tuple)<@[A, B], 
	             [(qid('Prelude', ','), A --> B --> tid('Prelude', tuple)<@[A,B]) ] ),
	export_type(tid('Prelude', 'Bool')<@[],      
	             [(qid('Prelude', 'True'),  tid('Prelude', 'Bool')<@[]), 
		      (qid('Prelude', 'False'), tid('Prelude', 'Bool')<@[])]), 
	export_type(tid('Prelude', 'Int')<@[],  []),
	export_type(tid('Prelude', 'Char')<@[], []),
	%% FIXME: Should be a type alias, 
        export_type(tid('Prelude', 'String')<@[], []),
	export_type(tid('Prelude', 'Success')<@[], 
	                [(qid('Prelude', 'Success'), tid('Prelude', 'Success')<@[]),
			 (qid('Prelude', 'Failure'), tid('Prelude', 'Success')<@[])]),
	!.
	
%% Translation of constructors.

export_type(Name, ConsL) :-
	portray_clause(exports(type(Name, ConsL))),
	!.

%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

