module State where

data State a = St (a -> (a, Int))

newState :: State a
newState = St (mkState 0)

mkState :: Int -> a -> (a, Int)
mkState i a = (a, i)

incState :: State a -> State a
incState (St f) = St (incT f)

incT :: (a -> (a, Int)) -> a -> (a, Int)
incT f a = incT2 (f a)

incT2 :: (a, Int) -> (a, Int)
incT2 (a, n) = (a, n+1)

applySt :: State a -> a -> (a, Int)
applySt (St f) a = f a

main :: (Int, Int)
main = applySt (incState newState) 3
