module Sudoku where

import Fd

-- Thanks to Manuel Carro.

sudoku1 :: [[Int]]
sudoku1 = let v11, v12, v13, v14, v15, v16, v17, v18, v19,
                 v21, v22, v23, v24, v25, v26, v27, v28, v29,
                 v31, v32, v33, v34, v35, v36, v37, v38, v39,
                 v41, v42, v43, v44, v45, v46, v47, v48, v49,
                 v51, v52, v53, v54, v55, v56, v57, v58, v59,
                 v61, v62, v63, v64, v65, v66, v67, v68, v69,
                 v71, v72, v73, v74, v75, v76, v77, v78, v79,                    
                 v81, v82, v83, v84, v85, v86, v87, v88, v89,
                 v91, v92, v93, v94, v95, v96, v97, v98, v99 free in

                    [[v11, v12, v13, v14, v15, v16, v17, v18, v19],
                     [v21, v22, v23, v24, v25, v26, v27, v28, v29],
                     [v31, v32, v33, v34, v35, v36, v37, v38, v39],
                     [v41, v42, v43, v44, v45, v46, v47, v48, v49],
                     [v51, v52, v53, v54, v55, v56, v57, v58, v59],
                     [v61, v62, v63, v64, v65, v66, v67, v68, v69],
                     [v71, v72, v73, v74, v75, v76, v77, v78, v79],                    
                     [v81, v82, v83, v84, v85, v86, v87, v88, v89],
                     [v91, v92, v93, v94, v95, v96, v97, v98, v99]]


-- From El Mundo, Sat. 23
--  [_,_,_,1,_,3,8,_,_],
--  [_,_,6,2,_,_,_,5,3],
--  [7,_,9,_,5,_,_,1,_],
--  [3,_,_,5,7,_,_,_,_],
--  [_,_,_,_,_,_,_,_,_],
--  [_,4,_,_,_,_,1,_,7],
--  [9,5,7,8,_,_,6,_,_],
--  [_,_,_,_,_,2,_,_,_],
--  [_,_,8,_,1,_,_,_,9]

sudoku2 :: [[Int]]
sudoku2 = let v11, v12, v13, v14, v15, v16, v17, v18, v19,
                 v21, v22, v23, v24, v25, v26, v27, v28, v29,
                 v31, v32, v33, v34, v35, v36, v37, v38, v39,
                 v41, v42, v43, v44, v45, v46, v47, v48, v49,
                 v51, v52, v53, v54, v55, v56, v57, v58, v59,
                 v61, v62, v63, v64, v65, v66, v67, v68, v69,
                 v71, v72, v73, v74, v75, v76, v77, v78, v79,                    
                 v81, v82, v83, v84, v85, v86, v87, v88, v89,
                 v91, v92, v93, v94, v95, v96, v97, v98, v99 free in

                    [[v11, v12, v13,   1, v15,   3,   8, v18, v19],
                     [v21, v22,   6,   2, v25, v26, v27,   5,   3],
                     [  7, v32,   9, v34,   5, v36, v37,   1, v39],
                     [  3, v42, v43,   5,   7, v46, v47, v48, v49],
                     [v51, v52, v53, v54, v55, v56, v57, v58, v59],
                     [v61,   4, v63, v64, v65, v66,   1, v68,   7],
                     [  9,   5,   7,   8, v75, v76,   6, v78, v79],                    
                     [v81, v82, v83, v84, v85,   2, v87, v88, v89],
                     [v91, v92,   8, v94,   1, v96, v97, v98,   9]]

-- From The Times online: "very hard"

--   [_,4,3,_,8,_,2,5,_],
--   [6,_,_,_,_,_,_,_,_],
--   [_,_,_,_,_,1,_,9,4],
--   [9,_,_,_,_,4,_,7,_],
--   [_,_,_,6,_,8,_,_,_],
--   [_,1,_,2,_,_,_,_,3],
--   [8,2,_,5,_,_,_,_,_],
--   [_,_,_,_,_,_,_,_,5],
--   [_,3,4,_,9,_,7,1,_],

sudoku3 :: [[Int]]
sudoku3 = let v11, v12, v13, v14, v15, v16, v17, v18, v19,
                 v21, v22, v23, v24, v25, v26, v27, v28, v29,
                 v31, v32, v33, v34, v35, v36, v37, v38, v39,
                 v41, v42, v43, v44, v45, v46, v47, v48, v49,
                 v51, v52, v53, v54, v55, v56, v57, v58, v59,
                 v61, v62, v63, v64, v65, v66, v67, v68, v69,
                 v71, v72, v73, v74, v75, v76, v77, v78, v79,                    
                 v81, v82, v83, v84, v85, v86, v87, v88, v89,
                 v91, v92, v93, v94, v95, v96, v97, v98, v99 free in

                    [[v11,   4,   3, v14,   8, v16,   2,   5, v19],
                     [  6, v22, v23, v24, v25, v26, v27, v28, v29],
                     [v31, v32, v33, v34, v35,   1, v37,   9,   4],
                     [  9, v42, v43, v44, v45,   4, v47,   7, v49],
                     [v51, v52, v53,   6, v55,   8, v57, v58, v59],
                     [v61,   1, v63,   2, v65, v66, v67, v68,   3],
                     [  8,   2, v73,   5, v75, v76, v77, v78, v79],                    
                     [v81, v82, v83, v84, v85, v86, v87, v88,   5],
                     [v91,   3,   4, v94,   9, v96,   7,   1, v99]]


-- Only works for square matrix.
get_vertical :: Int -> [[Int]] -> [Int]
get_vertical n ll = map (\l -> l!!n) ll

transpose_m :: [[Int]] -> [[Int]]
transpose_m l = map (\n -> get_vertical n l) [0,1,2,3,4,5,6,7,8]

-- Obtains lists of the sudoku's squares.
get_squares :: [[Int]] -> [[Int]]
get_squares ll = map (\v -> get_square v ll) [(0,0), (0,3), (0,6), (3,0), (3,3), (3,6), (6,0), (6,3), (6,6)]

get_square :: (Int, Int) -> [[Int]] -> [Int]
get_square (x, y) l = let [f1,f2,f3] = take 3 (drop x l) in -- Get The files
                          take 3 (drop y f1) ++ take 3 (drop y f2) ++ take 3 (drop y f3)

constraint_values :: [Int] -> Int -> [Int]
constraint_values l n = map (\v -> in_range v (1,n) &> v) l

range_sudoku :: [[Int]] -> [[Int]]
range_sudoku l = map (\l -> constraint_values l 9) l

all_diff :: [[Int]] -> Success
all_diff [] = success
all_diff (l : ls) = let v free in all_different (tonf l) =:= v & all_diff ls

sudoku :: [[Int]] -> [[Int]]
sudoku sd = let m = range_sudoku sd in
                 all_diff (tonf m) & 
                 all_diff (tonf (transpose_m m)) & 
                 all_diff (tonf (get_squares m) ) &> map (\l -> labeling l) (tonf m)

main :: [[Int]]
main = sudoku sudoku3
